#include "Hardware/KEY/key.h"


//------------------------------  ------------------------------
/*
    B7    B6   B5   B4   B3   B2   B1   B0
    [H]  [G]  [F]  [E]  [D]  [C]  [B]  [A]
[0] H1   G1   F1   E1   D1   C1   B1   A1
[1] H2   G2   F2   E2   D2   C2   B2   A2
[2] H3   G3   F3   E3   D3   C3   B3   A3
[3] H4   G4   F4   E4   D4   C4   B4   A4
[4] H5   G5   F5   E5   D5   C5   B5   A5
[5] H6   G6   F6   E6   D6   C6   B6   A6
[6] H7   G7   F7   E7   D7   C7   B7   A7
[7] H8   G8   F8   E8   D8   C8   B8   A8
*/

u8  xdata Key_LastState[Matrix_Key_Col_num] = {0};                  // 8 λ b0=1k1һΰ¹
u8  xdata Key_Press[Matrix_Key_Col_num] = {0x00};                   // 8*8 Ƿ
u16 xdata Key_Count[Matrix_Key_Col_num][Matrix_Key_Row_num] = {0};  // 8*8 µʱ
u8  xdata Key_Stata[Matrix_Key_Col_num][Matrix_Key_Row_num] = {0};  // 8*8 µ״̬

//------------------------------  ------------------------------

/**
 * @name GPIO_Key_Init
 * @brief 󰴼GPIOڳʼ
 * @version 汾v1.0
 * @date ڣ2024-04-22
 * @author ߣϫ
 * @note עͣΪΪ1ʱ
 */
void GPIO_Key_Init(void)
{
    // P2  ABCDEFGH 
    P2M0 = 0xff; P2M1 = 0x00; 
    // P2PU = 0xff; 
    P2PD = 0xff; 

    // P0  12345678  
    P0M0 = 0x00; P0M1 = 0xff; 
    P0PD = 0xff; 
}


/**
 * @name Matrix_keyboard_Scan
 * @brief 󰴼ɨ
 * @version 汾v1.0
 * @date ڣ2024-04-22
 * @author ߣϫ
 * @note עͣ
 */
void Matrix_keyboard_Scan(void)
{
    u8 i = 0;

    KEY_Col = 0x01;                     // ӦУ1
    for ( i = 0; i < 8; i++)
    {
        _nop_();                        // ȴ
        Key_Press[i] = KEY_Row;         // ֵΪ1
        KEY_Col = _crol_(KEY_Col, 1);   // ɨһ
    }
}


/**
 * @name Matrix_keyboard_ReadState
 * @brief ȡָİť״̬
 * @param key_col :  ABCDEFGH
 * @param key_row :  12345678
 * @return ע
 * @version 汾v1.0
 * @date ڣ2024-04-25
 * @author ߣ
 * @note עͣ
 *              KEY_NOPRESS		0		// δ
 *              KEY_FILCKER		1		// 
 *              KEY_PRESS		2		// 
 *              KEY_PRESSOVER	3		// 
 *              KEY_LONGPRESS	4		// n
 *              KEY_LONGOVER    5		// 
 *              KEY_RELAX		6		// ɿ
 */
u8 Matrix_keyboard_ReadState(u8 key_col, u8 key_row)  // ȡָİ״̬ 10msִһ
{
    if (Key_Count[key_col][key_row] > 0) // ǰµĸ״̬
    {
        if (Key_Count[key_col][key_row] < 3) // <30ms ״̬
        {
            return KEY_FILCKER;
        }
        else if (Key_Count[key_col][key_row] == 3) // 30ms ص
        {
            return KEY_PRESS;
        }
        else if (Key_Count[key_col][key_row] < 200) // ²2000ms ص
        {
            return KEY_PRESSOVER;
        }
        else if (Key_Count[key_col][key_row] == 200) // 2000ms س״̬
        {
            return KEY_LONGPRESS;
        }
        else // 
        {
            return KEY_LONGOVER;
        }
    }
    else // Ѿɿˣظ״̬
    {
        if (Key_LastState[key_col] & (1 << key_row))    // ֮ǰ¹
        {
            return KEY_RELAX;
        }
        else // ֮ǰûа
        {
            return KEY_NOPRESS;
        }
    }
}

/**
 * @name Matrix_keyboard_Deal
 * @brief ״̬
 * @version 汾v1.0
 * @date ڣ2024-04-25
 * @author ߣϫ
 * @note עͣеİ״̬ 10msִһ
 */
void Matrix_keyboard_Deal(void)
{
    u8 i, j, t;

    Matrix_keyboard_Scan();
    for ( i = 0; i < 8; i++)
    {
        for ( j = 0; j < 8; j++)                //  ABCDEFGH
        {
            if ( Key_Press[i] & (0x01 << j) )   //  12345678
            {
                if (Key_Count[i][j] < 60000)
                    Key_Count[i][j] += 1;       // £+1

                t = Matrix_keyboard_ReadState(i, j);
                if( t == KEY_LONGPRESS )
                    Key_Stata[i][j] = KEY_LONGPRESS;
                else
                    Key_Stata[i][j] = 0;
            }
            else // ɿˣ0
            {
                if (Key_Count[i][j] > 0)    // ǰ¹
                {
                    Key_LastState[i] |= (1 << j);   // Ӧı־λλ
                }
                else
                {
                    Key_LastState[i] &= ~(1 << j);  // Ӧı־λ0
                }
                Key_Stata[i][j] = Matrix_keyboard_ReadState(i, j);
                Key_Count[i][j] = 0;    // £0
            }
        }
    }
}
